diff -Naur openssl-1.0.0q.orig/crypto/evp/p_dec.c openssl-1.0.0q/crypto/evp/p_dec.c
--- openssl-1.0.0q.orig/crypto/evp/p_dec.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/p_dec.c	2017-04-25 16:23:40.424620444 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/rand.h>
 #ifndef OPENSSL_NO_RSA
diff -Naur openssl-1.0.0q.orig/crypto/evp/p_enc.c openssl-1.0.0q/crypto/evp/p_enc.c
--- openssl-1.0.0q.orig/crypto/evp/p_enc.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/p_enc.c	2017-04-25 16:23:40.425620013 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/rand.h>
 #ifndef OPENSSL_NO_RSA
diff -Naur openssl-1.0.0q.orig/crypto/evp/p_lib.c openssl-1.0.0q/crypto/evp/p_lib.c
--- openssl-1.0.0q.orig/crypto/evp/p_lib.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/p_lib.c	2017-04-25 16:23:40.426620140 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/bn.h>
 #include <openssl/err.h>
 #include <openssl/objects.h>
@@ -78,7 +80,7 @@
 #include <openssl/engine.h>
 #endif
 
-#include "asn1_locl.h"
+#include "../asn1/asn1_locl.h"
 
 static void EVP_PKEY_free_it(EVP_PKEY *x);
 
@@ -89,13 +91,16 @@
 	return 0;
 	}
 
+#if defined(LIBOPEAY_ASYNCHRONOUS_KEYGENERATION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION) || defined(USE_OPENSSL_CERTIFICATE_VERIFICATION)
 int EVP_PKEY_size(EVP_PKEY *pkey)
 	{
 	if (pkey && pkey->ameth && pkey->ameth->pkey_size)
 		return pkey->ameth->pkey_size(pkey);
 	return 0;
 	}
+#endif // defined(LIBOPEAY_ASYNCHRONOUS_KEYGENERATION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION) || defined(USE_OPENSSL_CERTIFICATE_VERIFICATION)
 
+#ifndef OPERA_SMALL_VERSION
 int EVP_PKEY_save_parameters(EVP_PKEY *pkey, int mode)
 	{
 #ifndef OPENSSL_NO_DSA
@@ -120,6 +125,7 @@
 #endif
 	return(0);
 	}
+#endif // !OPERA_SMALL_VERSION
 
 int EVP_PKEY_copy_parameters(EVP_PKEY *to, const EVP_PKEY *from)
 	{
@@ -147,6 +153,7 @@
 	return 0;
 	}
 
+#if defined(LIBOPEAY_PKCS12_SUPPORT) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION) || defined(USE_OPENSSL_CERTIFICATE_VERIFICATION)
 int EVP_PKEY_cmp_parameters(const EVP_PKEY *a, const EVP_PKEY *b)
 	{
 	if (a->type != b->type)
@@ -178,6 +185,7 @@
 
 	return -2;
 	}
+#endif // defined(LIBOPEAY_PKCS12_SUPPORT) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 
 EVP_PKEY *EVP_PKEY_new(void)
 	{
@@ -260,19 +268,22 @@
 	return pkey_set_type(pkey, EVP_PKEY_NONE, str, len);
 	}
 
+#if defined(LIBOPEAY_PKCS12_SUPPORT) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION) || defined(USE_OPENSSL_CERTIFICATE_VERIFICATION)
 int EVP_PKEY_assign(EVP_PKEY *pkey, int type, void *key)
 	{
 	if (!EVP_PKEY_set_type(pkey, type))
 		return 0;
-	pkey->pkey.ptr=key;
+	pkey->pkey.ptr=(char*)key;
 	return (key != NULL);
 	}
+#endif // defined(LIBOPEAY_PKCS12_SUPPORT) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION) || defined(USE_OPENSSL_CERTIFICATE_VERIFICATION)
 
 void *EVP_PKEY_get0(EVP_PKEY *pkey)
 	{
 	return pkey->pkey.ptr;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 #ifndef OPENSSL_NO_RSA
 int EVP_PKEY_set1_RSA(EVP_PKEY *pkey, RSA *key)
 {
@@ -356,6 +367,7 @@
 	return pkey->pkey.dh;
 }
 #endif
+#endif // !OPERA_SMALL_VERSION
 
 int EVP_PKEY_type(int type)
 	{
@@ -403,8 +415,10 @@
 		}
 #endif
 	EVP_PKEY_free_it(x);
+#ifdef LIBOPEAY_PKCS12_SUPPORT
 	if (x->attributes)
 		sk_X509_ATTRIBUTE_pop_free(x->attributes, X509_ATTRIBUTE_free);
+#endif
 	OPENSSL_free(x);
 	}
 
diff -Naur openssl-1.0.0q.orig/crypto/evp/p_open.c openssl-1.0.0q/crypto/evp/p_open.c
--- openssl-1.0.0q.orig/crypto/evp/p_open.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/p_open.c	2017-04-25 16:23:40.427619988 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 
 #ifndef OPENSSL_NO_RSA
 
diff -Naur openssl-1.0.0q.orig/crypto/evp/p_seal.c openssl-1.0.0q/crypto/evp/p_seal.c
--- openssl-1.0.0q.orig/crypto/evp/p_seal.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/p_seal.c	2017-04-25 16:23:40.427619988 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/rand.h>
 #ifndef OPENSSL_NO_RSA
diff -Naur openssl-1.0.0q.orig/crypto/evp/p_sign.c openssl-1.0.0q/crypto/evp/p_sign.c
--- openssl-1.0.0q.orig/crypto/evp/p_sign.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/p_sign.c	2017-04-25 16:23:40.428620115 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/evp.h>
 #include <openssl/objects.h>
 #include <openssl/x509.h>
@@ -78,7 +80,7 @@
 int EVP_SignFinal(EVP_MD_CTX *ctx, unsigned char *sigret, unsigned int *siglen,
 	     EVP_PKEY *pkey)
 	{
-	unsigned char m[EVP_MAX_MD_SIZE];
+	unsigned char m[EVP_MAX_MD_SIZE]; /* ARRAY OK 2009-05-25 yngve */
 	unsigned int m_len;
 	int i,ok=0,v;
 	EVP_MD_CTX tmp_ctx;
diff -Naur openssl-1.0.0q.orig/crypto/evp/p_verify.c openssl-1.0.0q/crypto/evp/p_verify.c
--- openssl-1.0.0q.orig/crypto/evp/p_verify.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/p_verify.c	2017-04-25 16:23:40.429620521 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/evp.h>
 #include <openssl/objects.h>
 #include <openssl/x509.h>
@@ -65,7 +67,7 @@
 int EVP_VerifyFinal(EVP_MD_CTX *ctx, const unsigned char *sigbuf,
 	     unsigned int siglen, EVP_PKEY *pkey)
 	{
-	unsigned char m[EVP_MAX_MD_SIZE];
+	unsigned char m[EVP_MAX_MD_SIZE]; /* ARRAY OK 2009-05-25 yngve */
 	unsigned int m_len;
 	int i,ok=0,v;
 	EVP_MD_CTX tmp_ctx;
diff -Naur openssl-1.0.0q.orig/crypto/evp/pmeth_fn.c openssl-1.0.0q/crypto/evp/pmeth_fn.c
--- openssl-1.0.0q.orig/crypto/evp/pmeth_fn.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/pmeth_fn.c	2017-04-25 16:23:40.430620090 +0200
@@ -56,9 +56,12 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/objects.h>
 #include <openssl/evp.h>
 #include "evp_locl.h"
diff -Naur openssl-1.0.0q.orig/crypto/evp/pmeth_gn.c openssl-1.0.0q/crypto/evp/pmeth_gn.c
--- openssl-1.0.0q.orig/crypto/evp/pmeth_gn.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/pmeth_gn.c	2017-04-25 16:23:40.430620090 +0200
@@ -56,9 +56,12 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/objects.h>
 #include <openssl/evp.h>
 #include <openssl/bn.h>
@@ -178,7 +181,7 @@
 
 static int trans_cb(int a, int b, BN_GENCB *gcb)
 	{
-	EVP_PKEY_CTX *ctx = gcb->arg;
+	EVP_PKEY_CTX *ctx = (EVP_PKEY_CTX *)gcb->arg;
 	ctx->keygen_info[0] = a;
 	ctx->keygen_info[1] = b;
 	return ctx->pkey_gencb(ctx);
diff -Naur openssl-1.0.0q.orig/crypto/evp/pmeth_lib.c openssl-1.0.0q/crypto/evp/pmeth_lib.c
--- openssl-1.0.0q.orig/crypto/evp/pmeth_lib.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/pmeth_lib.c	2017-04-25 16:23:40.431620217 +0200
@@ -56,41 +56,54 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/objects.h>
 #include <openssl/evp.h>
 #ifndef OPENSSL_NO_ENGINE
 #include <openssl/engine.h>
 #endif
-#include "asn1_locl.h"
+#include "../asn1/asn1_locl.h"
 #include "evp_locl.h"
+#include "modules/libopeay/libopeay_arrays.h"
+
 
 typedef int sk_cmp_fn_type(const char * const *a, const char * const *b);
 
 DECLARE_STACK_OF(EVP_PKEY_METHOD)
 STACK_OF(EVP_PKEY_METHOD) *app_pkey_methods = NULL;
 
+#define  rsa_pkey_meth OPENSSL_GLOBAL_ITEM_NAME(rsa_pmeth__rsa_pkey_meth )
+#define   dh_pkey_meth OPENSSL_GLOBAL_ITEM_NAME( dh_pmeth__dh_pkey_meth  )
+#define  dsa_pkey_meth OPENSSL_GLOBAL_ITEM_NAME(dsa_pmeth__dsa_pkey_meth )
+#define   ec_pkey_meth OPENSSL_GLOBAL_ITEM_NAME( ec_pmeth__ec_pkey_meth  )
+#define hmac_pkey_meth OPENSSL_GLOBAL_ITEM_NAME( hm_pmeth__hmac_pkey_meth)
+
+#ifdef HAS_COMPLEX_GLOBALS
 extern const EVP_PKEY_METHOD rsa_pkey_meth, dh_pkey_meth, dsa_pkey_meth;
 extern const EVP_PKEY_METHOD ec_pkey_meth, hmac_pkey_meth;
+#endif // HAS_COMPLEX_GLOBALS
 
-static const EVP_PKEY_METHOD *standard_methods[] =
-	{
+OPENSSL_PREFIX_CONST_ARRAY(static, const EVP_PKEY_METHOD*, pmeth_lib__standard_methods, libopeay)
 #ifndef OPENSSL_NO_RSA
-	&rsa_pkey_meth,
+	CONST_ENTRY(&rsa_pkey_meth)
 #endif
 #ifndef OPENSSL_NO_DH
-	&dh_pkey_meth,
+	CONST_ENTRY(&dh_pkey_meth)
 #endif
 #ifndef OPENSSL_NO_DSA
-	&dsa_pkey_meth,
+	CONST_ENTRY(&dsa_pkey_meth)
 #endif
 #ifndef OPENSSL_NO_EC
-	&ec_pkey_meth,
+	CONST_ENTRY(&ec_pkey_meth)
 #endif
-	&hmac_pkey_meth,
-	};
+	CONST_ENTRY(&hmac_pkey_meth)
+CONST_END(pmeth_lib__standard_methods)
+#define standard_methods OPENSSL_GLOBAL_ARRAY_NAME(pmeth_lib__standard_methods)
 
 DECLARE_OBJ_BSEARCH_CMP_FN(const EVP_PKEY_METHOD *, const EVP_PKEY_METHOD *,
 			   pmeth);
@@ -117,7 +130,7 @@
 			return sk_EVP_PKEY_METHOD_value(app_pkey_methods, idx);
 		}
 	ret = OBJ_bsearch_pmeth(&t, standard_methods,
-			  sizeof(standard_methods)/sizeof(EVP_PKEY_METHOD *));
+			OPENSSL_CONST_ARRAY_SIZE(pmeth_lib__standard_methods));
 	if (!ret || !*ret)
 		return NULL;
 	return *ret;
@@ -164,7 +177,7 @@
 		return NULL;
 		}
 
-	ret = OPENSSL_malloc(sizeof(EVP_PKEY_CTX));
+	ret = (EVP_PKEY_CTX *)OPENSSL_malloc(sizeof(EVP_PKEY_CTX));
 	if (!ret)
 		{
 #ifndef OPENSSL_NO_ENGINE
@@ -199,7 +212,7 @@
 EVP_PKEY_METHOD* EVP_PKEY_meth_new(int id, int flags)
 	{
 	EVP_PKEY_METHOD *pmeth;
-	pmeth = OPENSSL_malloc(sizeof(EVP_PKEY_METHOD));
+	pmeth = (EVP_PKEY_METHOD *)OPENSSL_malloc(sizeof(EVP_PKEY_METHOD));
 	if (!pmeth)
 		return NULL;
 
@@ -264,7 +277,7 @@
 		return 0;
 		}
 #endif
-	rctx = OPENSSL_malloc(sizeof(EVP_PKEY_CTX));
+	rctx = (EVP_PKEY_CTX *)OPENSSL_malloc(sizeof(EVP_PKEY_CTX));
 	if (!rctx)
 		return NULL;
 
diff -Naur openssl-1.0.0q.orig/crypto/ex_data.c openssl-1.0.0q/crypto/ex_data.c
--- openssl-1.0.0q.orig/crypto/ex_data.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/ex_data.c	2017-04-25 16:23:40.433620192 +0200
@@ -138,7 +138,12 @@
  *
  */
 
-#include "cryptlib.h"
+#ifndef OPERA_SMALL_VERSION
+#include <stdio.h>
+#include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/buffer.h>
+#include <openssl/cryptlib.h>
 #include <openssl/lhash.h>
 
 /* What an "implementation of ex_data functionality" looks like */
@@ -167,26 +172,40 @@
 			CRYPTO_EX_DATA *ad);
 	};
 
+#ifndef OPERA_SMALL_VERSION
 /* The implementation we use at run-time */
 static const CRYPTO_EX_DATA_IMPL *impl = NULL;
 
 /* To call "impl" functions, use this macro rather than referring to 'impl' directly, eg.
  * EX_IMPL(get_new_index)(...); */
 #define EX_IMPL(a) impl->cb_##a
+#else /* OPERA_SMALL_VERSION */
+#define EX_IMPL(a) int_##a
+#endif /* OPERA_SMALL_VERSION */
+
 
 /* Predeclare the "default" ex_data implementation */
+#ifndef OPERA_SMALL_VERSION
 static int int_new_class(void);
+#endif
+
 static void int_cleanup(void);
+#if !defined OPERA_SMALL_VERSION || defined LIBOPEAY_X509_EX_DATA
 static int int_get_new_index(int class_index, long argl, void *argp,
 		CRYPTO_EX_new *new_func, CRYPTO_EX_dup *dup_func,
 		CRYPTO_EX_free *free_func);
+#endif
 static int int_new_ex_data(int class_index, void *obj,
 		CRYPTO_EX_DATA *ad);
+#if !defined(OPERA_SMALL_VERSION) || defined (EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 static int int_dup_ex_data(int class_index, CRYPTO_EX_DATA *to,
 		CRYPTO_EX_DATA *from);
+#endif
 static void int_free_ex_data(int class_index, void *obj,
 		CRYPTO_EX_DATA *ad);
-static CRYPTO_EX_DATA_IMPL impl_default =
+
+#ifndef OPERA_SMALL_VERSION
+static const CRYPTO_EX_DATA_IMPL impl_default =
 	{
 	int_new_class,
 	int_cleanup,
@@ -208,13 +227,18 @@
 /* A macro wrapper for impl_check that first uses a non-locked test before
  * invoking the function (which checks again inside a lock). */
 #define IMPL_CHECK if(!impl) impl_check();
+#else  /* OPERA_SMALL_VERSION */
+#define IMPL_CHECK
+#endif /* OPERA_SMALL_VERSION */
 
+#ifndef OPERA_SMALL_VERSION
 /* API functions to get/set the "ex_data" implementation */
 const CRYPTO_EX_DATA_IMPL *CRYPTO_get_ex_data_implementation(void)
 	{
 	IMPL_CHECK
 	return impl;
 	}
+
 int CRYPTO_set_ex_data_implementation(const CRYPTO_EX_DATA_IMPL *i)
 	{
 	int toret = 0;
@@ -227,6 +251,7 @@
 	CRYPTO_w_unlock(CRYPTO_LOCK_EX_DATA);
 	return toret;
 	}
+#endif // OPERA_SMALL_VERSION
 
 /****************************************************************************/
 /* Interal (default) implementation of "ex_data" support. API functions are
@@ -242,11 +267,18 @@
 } EX_CLASS_ITEM;
 
 /* When assigning new class indexes, this is our counter */
+#ifndef OPERA_SMALL_VERSION
 static int ex_class = CRYPTO_EX_INDEX_USER;
+#endif // OPERA_SMALL_VERSION
 
 /* The global hash table of EX_CLASS_ITEM items */
 DECLARE_LHASH_OF(EX_CLASS_ITEM);
+#ifdef OPERA_SMALL_VERSION
+OPENSSL_IMPLEMENT_GLOBAL(LHASH_OF(EX_CLASS_ITEM) *, ex_data);
+#define ex_data OPENSSL_GLOBAL_REF(ex_data)
+#else
 static LHASH_OF(EX_CLASS_ITEM) *ex_data = NULL;
+#endif // OPERA_SMALL_VERSION
 
 /* The callbacks required in the "ex_data" hash table */
 static unsigned long ex_class_item_hash(const EX_CLASS_ITEM *a)
@@ -302,10 +334,10 @@
 	EX_DATA_CHECK(return NULL;)
 	d.class_index = class_index;
 	CRYPTO_w_lock(CRYPTO_LOCK_EX_DATA);
-	p = lh_EX_CLASS_ITEM_retrieve(ex_data, &d);
+	p = (EX_CLASS_ITEM *) lh_EX_CLASS_ITEM_retrieve(ex_data, &d);
 	if(!p)
 		{
-		gen = OPENSSL_malloc(sizeof(EX_CLASS_ITEM));
+		gen = (EX_CLASS_ITEM *) OPENSSL_malloc(sizeof(EX_CLASS_ITEM));
 		if(gen)
 			{
 			gen->class_index = class_index;
@@ -328,6 +360,7 @@
 	return p;
 	}
 
+#if !defined OPERA_SMALL_VERSION || defined LIBOPEAY_X509_EX_DATA
 /* Add a new method to the given EX_CLASS_ITEM and return the corresponding
  * index (or -1 for error). Handles locking. */
 static int def_add_index(EX_CLASS_ITEM *item, long argl, void *argp,
@@ -363,10 +396,12 @@
 	CRYPTO_w_unlock(CRYPTO_LOCK_EX_DATA);
 	return toret;
 	}
+#endif
 
 /**************************************************************/
 /* The functions in the default CRYPTO_EX_DATA_IMPL structure */
 
+#if !defined OPERA_SMALL_VERSION
 static int int_new_class(void)
 	{
 	int toret;
@@ -375,6 +410,7 @@
 	CRYPTO_w_unlock(CRYPTO_LOCK_EX_DATA);
 	return toret;
 	}
+#endif
 
 static void int_cleanup(void)
 	{
@@ -382,9 +418,12 @@
 	lh_EX_CLASS_ITEM_doall(ex_data, def_cleanup_cb);
 	lh_EX_CLASS_ITEM_free(ex_data);
 	ex_data = NULL;
+#ifndef OPERA_SMALL_VERSION
 	impl = NULL;
+#endif
 	}
 
+#if !defined OPERA_SMALL_VERSION || defined LIBOPEAY_X509_EX_DATA
 static int int_get_new_index(int class_index, long argl, void *argp,
 		CRYPTO_EX_new *new_func, CRYPTO_EX_dup *dup_func,
 		CRYPTO_EX_free *free_func)
@@ -394,6 +433,7 @@
 		return -1;
 	return def_add_index(item, argl, argp, new_func, dup_func, free_func);
 	}
+#endif
 
 /* Thread-safe by copying a class's array of "CRYPTO_EX_DATA_FUNCS" entries in
  * the lock, then using them outside the lock. NB: Thread-safety only applies to
@@ -414,7 +454,7 @@
 	mx = sk_CRYPTO_EX_DATA_FUNCS_num(item->meth);
 	if(mx > 0)
 		{
-		storage = OPENSSL_malloc(mx * sizeof(CRYPTO_EX_DATA_FUNCS*));
+		storage = (CRYPTO_EX_DATA_FUNCS **) OPENSSL_malloc(mx * sizeof(CRYPTO_EX_DATA_FUNCS*));
 		if(!storage)
 			goto skip;
 		for(i = 0; i < mx; i++)
@@ -441,6 +481,7 @@
 	return 1;
 	}
 
+#if !defined(OPERA_SMALL_VERSION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 /* Same thread-safety notes as for "int_new_ex_data" */
 static int int_dup_ex_data(int class_index, CRYPTO_EX_DATA *to,
 		CRYPTO_EX_DATA *from)
@@ -461,7 +502,7 @@
 		mx = j;
 	if(mx > 0)
 		{
-		storage = OPENSSL_malloc(mx * sizeof(CRYPTO_EX_DATA_FUNCS*));
+		storage = (CRYPTO_EX_DATA_FUNCS**)OPENSSL_malloc(mx * sizeof(CRYPTO_EX_DATA_FUNCS*));
 		if(!storage)
 			goto skip;
 		for(i = 0; i < mx; i++)
@@ -476,7 +517,7 @@
 		}
 	for(i = 0; i < mx; i++)
 		{
-		ptr = CRYPTO_get_ex_data(from, i);
+		ptr = (char*)CRYPTO_get_ex_data(from, i);
 		if(storage[i] && storage[i]->dup_func)
 			storage[i]->dup_func(to,from,&ptr,i,
 				storage[i]->argl,storage[i]->argp);
@@ -486,6 +527,7 @@
 		OPENSSL_free(storage);
 	return 1;
 	}
+#endif /* OPERA_SMALL_VERSION */
 
 /* Same thread-safety notes as for "int_new_ex_data" */
 static void int_free_ex_data(int class_index, void *obj,
@@ -501,7 +543,7 @@
 	mx = sk_CRYPTO_EX_DATA_FUNCS_num(item->meth);
 	if(mx > 0)
 		{
-		storage = OPENSSL_malloc(mx * sizeof(CRYPTO_EX_DATA_FUNCS*));
+		storage = (CRYPTO_EX_DATA_FUNCS **) OPENSSL_malloc(mx * sizeof(CRYPTO_EX_DATA_FUNCS*));
 		if(!storage)
 			goto skip;
 		for(i = 0; i < mx; i++)
@@ -538,11 +580,13 @@
 
 /* Obtain an index for a new class (not the same as getting a new index within
  * an existing class - this is actually getting a new *class*) */
+#ifndef OPERA_SMALL_VERSION
 int CRYPTO_ex_data_new_class(void)
 	{
 	IMPL_CHECK
 	return EX_IMPL(new_class)();
 	}
+#endif
 
 /* Release all "ex_data" state to prevent memory leaks. This can't be made
  * thread-safe without overhauling a lot of stuff, and shouldn't really be
@@ -554,6 +598,7 @@
 	EX_IMPL(cleanup)();
 	}
 
+#if !defined OPERA_SMALL_VERSION || defined LIBOPEAY_X509_EX_DATA
 /* Inside an existing class, get/register a new index. */
 int CRYPTO_get_ex_new_index(int class_index, long argl, void *argp,
 		CRYPTO_EX_new *new_func, CRYPTO_EX_dup *dup_func,
@@ -566,6 +611,7 @@
 			argl, argp, new_func, dup_func, free_func);
 	return ret;
 	}
+#endif
 
 /* Initialise a new CRYPTO_EX_DATA for use in a particular class - including
  * calling new() callbacks for each index in the class used by this variable */
@@ -577,14 +623,16 @@
 
 /* Duplicate a CRYPTO_EX_DATA variable - including calling dup() callbacks for
  * each index in the class used by this variable */
+#if !defined(OPERA_SMALL_VERSION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 int CRYPTO_dup_ex_data(int class_index, CRYPTO_EX_DATA *to,
 	     CRYPTO_EX_DATA *from)
 	{
 	IMPL_CHECK
 	return EX_IMPL(dup_ex_data)(class_index, to, from);
 	}
+#endif
 
-/* Cleanup a CRYPTO_EX_DATA variable - including calling free() callbacks for
+/* Cleanup a CRYPTO_EX_DATA variable - including calling op_free() callbacks for
  * each index in the class used by this variable */
 void CRYPTO_free_ex_data(int class_index, void *obj, CRYPTO_EX_DATA *ad)
 	{
@@ -617,7 +665,7 @@
 			}
 		i++;
 		}
-	sk_void_set(ad->sk,idx,val);
+	sk_void_set(ad->sk,idx, (char *) val);
 	return(1);
 	}
 
diff -Naur openssl-1.0.0q.orig/crypto/hmac/.gitignore openssl-1.0.0q/crypto/hmac/.gitignore
--- openssl-1.0.0q.orig/crypto/hmac/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/hmac/.gitignore	2017-04-25 16:23:40.433620192 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/hmac/hm_ameth.c openssl-1.0.0q/crypto/hmac/hm_ameth.c
--- openssl-1.0.0q.orig/crypto/hmac/hm_ameth.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/hmac/hm_ameth.c	2017-04-25 16:23:40.434620319 +0200
@@ -55,10 +55,16 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/evp.h>
-#include "asn1_locl.h"
+#include "../asn1/asn1_locl.h"
+
+#include "modules/libopeay/libopeay_arrays.h"
+
 
 #define HMAC_TEST_PRIVATE_KEY_FORMAT
 
@@ -122,7 +128,7 @@
 		{
 		if (!*pder)
 			{
-			*pder = OPENSSL_malloc(os->length);
+			*pder = (unsigned char *)OPENSSL_malloc(os->length);
 			inc = 0;
 			}
 		else inc = 1;
@@ -138,14 +144,13 @@
 
 #endif
 
-const EVP_PKEY_ASN1_METHOD hmac_asn1_meth = 
-	{
+CONST_EVP_PKEY_ASN1_METHOD_ITEM(hm_ameth__hmac_asn1_meth,
 	EVP_PKEY_HMAC,
 	EVP_PKEY_HMAC,
 	0,
 
-	"HMAC",
-	"OpenSSL HMAC method",
+	(char *)"HMAC",
+	(char *)"OpenSSL HMAC method",
 
 	0,0,0,0,
 
@@ -157,11 +162,6 @@
 
 	hmac_key_free,
 	hmac_pkey_ctrl,
-#ifdef HMAC_TEST_PRIVATE_KEY_FORMAT
 	old_hmac_decode,
 	old_hmac_encode
-#else
-	0,0
-#endif
-	};
-
+	);
diff -Naur openssl-1.0.0q.orig/crypto/hmac/hm_pmeth.c openssl-1.0.0q/crypto/hmac/hm_pmeth.c
--- openssl-1.0.0q.orig/crypto/hmac/hm_pmeth.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/hmac/hm_pmeth.c	2017-04-25 16:23:40.435619049 +0200
@@ -55,13 +55,17 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/x509.h>
 #include <openssl/x509v3.h>
 #include <openssl/evp.h>
 #include <openssl/hmac.h>
-#include "evp_locl.h"
+#include "../evp/evp_locl.h"
+#include "modules/libopeay/libopeay_arrays.h"
 
 /* HMAC pkey context structure */
 
@@ -75,7 +79,7 @@
 static int pkey_hmac_init(EVP_PKEY_CTX *ctx)
 	{
 	HMAC_PKEY_CTX *hctx;
-	hctx = OPENSSL_malloc(sizeof(HMAC_PKEY_CTX));
+	hctx = (HMAC_PKEY_CTX *)OPENSSL_malloc(sizeof(HMAC_PKEY_CTX));
 	if (!hctx)
 		return 0;
 	hctx->md = NULL;
@@ -96,8 +100,8 @@
 	HMAC_PKEY_CTX *sctx, *dctx;
 	if (!pkey_hmac_init(dst))
 		return 0;
-       	sctx = src->data;
-	dctx = dst->data;
+	sctx = (HMAC_PKEY_CTX *)src->data;
+	dctx = (HMAC_PKEY_CTX *)dst->data;
 	dctx->md = sctx->md;
 	HMAC_CTX_init(&dctx->ctx);
 	HMAC_CTX_copy(&dctx->ctx, &sctx->ctx);
@@ -112,7 +116,7 @@
 
 static void pkey_hmac_cleanup(EVP_PKEY_CTX *ctx)
 	{
-	HMAC_PKEY_CTX *hctx = ctx->data;
+	HMAC_PKEY_CTX *hctx = (HMAC_PKEY_CTX *)ctx->data;
 	HMAC_CTX_cleanup(&hctx->ctx);
 	if (hctx->ktmp.data)
 		{
@@ -127,7 +131,7 @@
 static int pkey_hmac_keygen(EVP_PKEY_CTX *ctx, EVP_PKEY *pkey)
 	{
 	ASN1_OCTET_STRING *hkey = NULL;
-	HMAC_PKEY_CTX *hctx = ctx->data;
+	HMAC_PKEY_CTX *hctx = (HMAC_PKEY_CTX *)ctx->data;
 	if (!hctx->ktmp.data)
 		return 0;
 	hkey = ASN1_OCTET_STRING_dup(&hctx->ktmp);
@@ -140,14 +144,14 @@
 
 static int int_update(EVP_MD_CTX *ctx,const void *data,size_t count)
 	{
-	HMAC_PKEY_CTX *hctx = ctx->pctx->data;
-	HMAC_Update(&hctx->ctx, data, count);
+	HMAC_PKEY_CTX *hctx = (HMAC_PKEY_CTX *)ctx->pctx->data;
+	HMAC_Update(&hctx->ctx, (const unsigned char *)data, count);
 	return 1;
 	}
 
 static int hmac_signctx_init(EVP_PKEY_CTX *ctx, EVP_MD_CTX *mctx)
 	{
-	HMAC_PKEY_CTX *hctx = ctx->data;
+	HMAC_PKEY_CTX *hctx = (HMAC_PKEY_CTX *)ctx->data;
 	HMAC_CTX_set_flags(&hctx->ctx, mctx->flags & ~EVP_MD_CTX_FLAG_NO_INIT);
 	EVP_MD_CTX_set_flags(mctx, EVP_MD_CTX_FLAG_NO_INIT);
 	mctx->update = int_update;
@@ -158,7 +162,7 @@
 					EVP_MD_CTX *mctx)
 	{
 	unsigned int hlen;
-	HMAC_PKEY_CTX *hctx = ctx->data;
+	HMAC_PKEY_CTX *hctx = (HMAC_PKEY_CTX *)ctx->data;
 	int l = EVP_MD_CTX_size(mctx);
 
 	if (l < 0)
@@ -174,7 +178,7 @@
 
 static int pkey_hmac_ctrl(EVP_PKEY_CTX *ctx, int type, int p1, void *p2)
 	{
-	HMAC_PKEY_CTX *hctx = ctx->data;
+	HMAC_PKEY_CTX *hctx = (HMAC_PKEY_CTX *)ctx->data;
 	ASN1_OCTET_STRING *key;
 	switch (type)
 		{
@@ -182,12 +186,12 @@
 		case EVP_PKEY_CTRL_SET_MAC_KEY:
 		if ((!p2 && p1 > 0) || (p1 < -1))
 			return 0;
-		if (!ASN1_OCTET_STRING_set(&hctx->ktmp, p2, p1))
+		if (!ASN1_OCTET_STRING_set(&hctx->ktmp, (const unsigned char *)p2, p1))
 			return 0;
 		break;
 
 		case EVP_PKEY_CTRL_MD:
-		hctx->md = p2;
+		hctx->md = (const EVP_MD *)p2;
 		break;
 
 		case EVP_PKEY_CTRL_DIGESTINIT:
@@ -231,8 +235,7 @@
 	return -2;
 	}
 
-const EVP_PKEY_METHOD hmac_pkey_meth = 
-	{
+CONST_EVP_PKEY_METHOD_ITEM(hm_pmeth__hmac_pkey_meth,
 	EVP_PKEY_HMAC,
 	0,
 	pkey_hmac_init,
@@ -264,4 +267,4 @@
 	pkey_hmac_ctrl,
 	pkey_hmac_ctrl_str
 
-	};
+	);
diff -Naur openssl-1.0.0q.orig/crypto/hmac/hmac.c openssl-1.0.0q/crypto/hmac/hmac.c
--- openssl-1.0.0q.orig/crypto/hmac/hmac.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/hmac/hmac.c	2017-04-25 16:23:40.436619735 +0200
@@ -55,17 +55,23 @@
  * copied and put under another distribution licence
  * [including the GNU Public Licence.]
  */
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/hmac.h>
+#include "modules/libopeay/libopeay_implmodule.h"
+
 
 int HMAC_Init_ex(HMAC_CTX *ctx, const void *key, int len,
 		  const EVP_MD *md, ENGINE *impl)
 	{
 	int i,j,reset=0;
-	unsigned char pad[HMAC_MAX_MD_CBLOCK];
+	unsigned char pad[HMAC_MAX_MD_CBLOCK]; /* ARRAY OK 2004-02-18 yngve */
 
 	if (md != NULL)
 		{
@@ -93,11 +99,11 @@
 		else
 			{
 			OPENSSL_assert(len>=0 && len<=(int)sizeof(ctx->key));
-			memcpy(ctx->key,key,len);
+			op_memcpy(ctx->key,key,len);
 			ctx->key_length=len;
 			}
 		if(ctx->key_length != HMAC_MAX_MD_CBLOCK)
-			memset(&ctx->key[ctx->key_length], 0,
+			op_memset(&ctx->key[ctx->key_length], 0,
 				HMAC_MAX_MD_CBLOCK - ctx->key_length);
 		}
 
@@ -139,7 +145,7 @@
 int HMAC_Final(HMAC_CTX *ctx, unsigned char *md, unsigned int *len)
 	{
 	unsigned int i;
-	unsigned char buf[EVP_MAX_MD_SIZE];
+	unsigned char buf[EVP_MAX_MD_SIZE]; /* ARRAY OK 2004-02-18 yngve */
 
 	if (!EVP_DigestFinal_ex(&ctx->md_ctx,buf,&i))
 		goto err;
@@ -169,7 +175,7 @@
 		goto err;
 	if (!EVP_MD_CTX_copy(&dctx->md_ctx, &sctx->md_ctx))
 		goto err;
-	memcpy(dctx->key, sctx->key, HMAC_MAX_MD_CBLOCK);
+	op_memcpy(dctx->key, sctx->key, HMAC_MAX_MD_CBLOCK);
 	dctx->key_length = sctx->key_length;
 	dctx->md = sctx->md;
 	return 1;
@@ -182,15 +188,22 @@
 	EVP_MD_CTX_cleanup(&ctx->i_ctx);
 	EVP_MD_CTX_cleanup(&ctx->o_ctx);
 	EVP_MD_CTX_cleanup(&ctx->md_ctx);
-	memset(ctx,0,sizeof *ctx);
+	op_memset(ctx,0,sizeof *ctx);
 	}
 
+#ifdef OPERA_SMALL_VERSION
+OPENSSL_IMPLEMENT_GLOBAL(Libopeay_ImplementModuleData::hmac__m_t, hmac__m);
+#define m OPENSSL_GLOBAL_REF(hmac__m)
+#endif
+
 unsigned char *HMAC(const EVP_MD *evp_md, const void *key, int key_len,
 		    const unsigned char *d, size_t n, unsigned char *md,
 		    unsigned int *md_len)
 	{
 	HMAC_CTX c;
+#ifndef OPERA_SMALL_VERSION
 	static unsigned char m[EVP_MAX_MD_SIZE];
+#endif
 
 	if (md == NULL) md=m;
 	HMAC_CTX_init(&c);
diff -Naur openssl-1.0.0q.orig/crypto/hmac/hmac.h openssl-1.0.0q/crypto/hmac/hmac.h
--- openssl-1.0.0q.orig/crypto/hmac/hmac.h	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/hmac/hmac.h	2017-04-25 16:23:40.436619735 +0200
@@ -79,7 +79,7 @@
 	EVP_MD_CTX i_ctx;
 	EVP_MD_CTX o_ctx;
 	unsigned int key_length;
-	unsigned char key[HMAC_MAX_MD_CBLOCK];
+	unsigned char key[HMAC_MAX_MD_CBLOCK]; /* ARRAY OK 2009-05-25 yngve */
 	} HMAC_CTX;
 
 #define HMAC_size(e)	(EVP_MD_size((e)->md))
diff -Naur openssl-1.0.0q.orig/crypto/hmac/hmactest.c openssl-1.0.0q/crypto/hmac/hmactest.c
--- openssl-1.0.0q.orig/crypto/hmac/hmactest.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/hmac/hmactest.c	2017-04-25 16:23:40.437619303 +0200
@@ -56,9 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include "../e_os.h"
 
@@ -147,7 +149,7 @@
 			test[i].data, test[i].data_len,
 			NULL,NULL));
 
-		if (strcmp(p,(char *)test[i].digest) != 0)
+		if (op_strcmp(p,(char *)test[i].digest) != 0)
 			{
 			printf("error calculating HMAC on %d entry'\n",i);
 			printf("got %s instead of %s\n",p,test[i].digest);
@@ -168,7 +170,7 @@
 	static char buf[80];
 
 	for (i=0; i<MD5_DIGEST_LENGTH; i++)
-		sprintf(&(buf[i*2]),"%02x",md[i]);
+		op_sprintf(&(buf[i*2]),"%02x",md[i]);
 	return(buf);
 	}
 #endif
diff -Naur openssl-1.0.0q.orig/crypto/idea/.gitignore openssl-1.0.0q/crypto/idea/.gitignore
--- openssl-1.0.0q.orig/crypto/idea/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/idea/.gitignore	2017-04-25 16:23:40.439619278 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/idea/i_ecb.c openssl-1.0.0q/crypto/idea/i_ecb.c
--- openssl-1.0.0q.orig/crypto/idea/i_ecb.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/idea/i_ecb.c	2017-04-25 16:23:40.440619684 +0200
@@ -60,7 +60,9 @@
 #include "idea_lcl.h"
 #include <openssl/opensslv.h>
 
-const char IDEA_version[]="IDEA" OPENSSL_VERSION_PTEXT;
+#ifndef OPERA_SMALL_VERSION
+const char IDEA_version[]="IDEA" OPENSSL_VERSION_PTEXT; /* ARRAY OK 2008-02-26 haavardm */
+#endif
 
 const char *idea_options(void)
 	{
diff -Naur openssl-1.0.0q.orig/crypto/idea/idea_spd.c openssl-1.0.0q/crypto/idea/idea_spd.c
--- openssl-1.0.0q.orig/crypto/idea/idea_spd.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/idea/idea_spd.c	2017-04-25 16:23:40.441619532 +0200
@@ -63,6 +63,7 @@
 #define TIMES
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 
 #include <openssl/e_os2.h>
@@ -98,6 +99,7 @@
 #include <limits.h>
 #include <sys/param.h>
 #endif
+#endif /* !OPERA_SMALL_VERSION */
 
 #include <openssl/idea.h>
 
